use gtk4 as gtk;
use gtk::{glib, gio, subclass::prelude::*};

mod imp {
    use super::*;
    
    #[derive(Debug, Default, gtk::CompositeTemplate)]
    #[template(file = "data/login_window.blp")]
    pub struct LoginWindow {
        #[template_child]
        pub forms_overlay: TemplateChild<gtk::Overlay>,
        #[template_child]
        pub forms_wrapper: TemplateChild<gtk::Box>,
        #[template_child]
        pub error_label: TemplateChild<gtk::Label>,
        #[template_child]
        pub device_entry: TemplateChild<gtk::Entry>,
        #[template_child]
        pub email_entry: TemplateChild<gtk::Entry>,
        #[template_child]
        pub password_entry: TemplateChild<gtk::PasswordEntry>,
        #[template_child]
        pub login_button: TemplateChild<gtk::Button>,
        #[template_child]
        pub api_key_entry: TemplateChild<gtk::PasswordEntry>,
        #[template_child]
        pub api_key_button: TemplateChild<gtk::Button>,
        #[template_child]
        pub device_entry_popover: TemplateChild<gtk::Popover>,
        #[template_child]
        pub loading_overlay: TemplateChild<gtk::Box>,
    }

    #[glib::object_subclass]
    impl ObjectSubclass for LoginWindow {
        const NAME: &'static str = "LoginWindow";
        type Type = super::LoginWindow;
        type ParentType = gtk::ApplicationWindow;

        fn class_init(class: &mut Self::Class) {
            class.bind_template();
        }

        fn instance_init(obj: &glib::subclass::InitializingObject<Self>) {
            obj.init_template();
        }
    }

    impl ObjectImpl for LoginWindow {}
    impl WidgetImpl for LoginWindow {}
    impl WindowImpl for LoginWindow {}
    impl ApplicationWindowImpl for LoginWindow {}
}

glib::wrapper! {
    pub struct LoginWindow(ObjectSubclass<imp::LoginWindow>)
        @extends gtk::Widget, gtk::Window, gtk::ApplicationWindow,
        @implements gio::ActionMap, gio::ActionGroup;
}

impl LoginWindow {
    pub fn new(app: &crate::application::Application) -> Self {
        glib::Object::builder().property("application", app).build()
    }
}
